#!/usr/bin/python

    # This is a tool to visualize .asc files.

    # Copyright (C) 2013  Author: Yexiang Xue

    # This program is free software: you can redistribute it and/or modify
    # it under the terms of the GNU General Public License as published by
    # the Free Software Foundation, either version 3 of the License, or
    # (at your option) any later version.

    # This program is distributed in the hope that it will be useful,
    # but WITHOUT ANY WARRANTY; without even the implied warranty of
    # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    # GNU General Public License for more details.

    # You should have received a copy of the GNU General Public License
    # along with this program.  If not, see <http://www.gnu.org/licenses/>. 

    # Contact Yexiang Xue at yexiang@cs.cornell.edu
    #         Bistra Dilkina at bistra@cs.cornell.edu

from pylab import *
import sys

def display(A):
    fig = figure(1)
    img = imshow(A, interpolation='nearest')
    grid(True)
    fig.colorbar(img)
    show()


def readMatrix(filename):
    inp = file(filename, 'r')
    
    l = inp.readline()
    tt = l.split()
    ncol = int(tt[1])

    l = inp.readline()
    tt = l.split()
    nrow = int(tt[1])
    
    l = inp.readline()
    l = inp.readline()
    l = inp.readline()
    l = inp.readline()
    
    A = rand(nrow, ncol)
    for i in range(0,nrow):
        l = inp.readline()
        tt = l.split()
        for j in range(0,ncol):
            A[i][j] = float(tt[j])

    return (nrow, ncol, A)

def normalize(A, nrow, ncol):
    big = -1000000
    for i in range(0, nrow):
        for j in range(0, ncol):
            if A[i][j] > big:
                big = A[i][j]
    for i in range(0, nrow):
        for j in range(0, ncol):
            A[i][j] = A[i][j] / big

filename = sys.argv[1]
#filename = 'random_30_split_6_species_4/random_81_res_2.asc'
#filename = 'random_30_split_6_species_4/random_81_cost.asc'

(nrow, ncol, A) = readMatrix(filename)

#print A
normalize(A, nrow, ncol)

display(A)
